@rem  THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
@rem  5724-I04 (C) COPYRIGHT International Business Machines Corp., 2011
@rem  All Rights Reserved * Licensed Materials - Property of IBM
@rem  US Government Users Restricted Rights - Use, duplication or disclosure
@rem  restricted by GSA ADP Schedule Contract with IBM Corp.
@echo off

SET APARID=IC80427
SET FIXFILENAME=wvsapp.ear
SET FIXFILENAME2=ibmgram.dll
@rem DESTDIR relative to $WVS_ROOT
SET DESTDIR=\ear
SET DESTDIR2=\ViaVoice\bin
SET APPNAME=wvsapp

REM Usage: ifix_%APARID%.bat -install
setlocal

@rem Check parameters
IF [%1] ==[] GOTO Syntax


@rem Try to setup the WAS command line environment by using the default WAS install location

if EXIST "C:\Program Files\IBM\WebSphere\AppServer\bin\setupCmdLine.bat" goto setupwas
   GOTO checkenv

:setupwas
call "C:\Program Files\IBM\WebSphere\AppServer\bin\setupCmdLine.bat"

:checkenv
@rem Check required Environment Variables are setup
IF  "%WAS_HOME%".== "". goto washome

IF  "%WVS_ROOT%".== "". goto wvsroot

GOTO:parms

:Syntax
 @echo.
 @echo Ifix_%APARID%: WVS Ifix %APARID% Installer
 @echo  to install ifix  syntax: ifix_%APARID%.bat -install
 @echo  to uninstall ifix  syntax: ifix_%APARID%.bat -uninstall
 @echo  off
 GOTO:EOF

:washome
  @echo.
  @echo Ifix_%APARID%: Please run WebSphere Application Servers setupCmdLine.bat to setup
  @echo          the WAS Command line environment
  @echo Ifix_%APARID%: The WebSphere Application Servers setupCmdLine.bat is located in WAS_HOME\bin directory.
  @echo.
  GOTO:EOF

:wvsroot
  @echo.
  @echo Ifix_%APARID%: Please configure WebSphere Voice Server wvs.setenv according
  @echo          to the WVS InfoCenter
  @echo.
  GOTO:EOF

:parms
set installoption=false
set uninstalloption=false

:loop
if '%1'=='-install' goto installoption
if '%1'=='-uninstall' goto uninstalloption
if '%1'=='' goto syntax
goto syntax

:installoption
set installoption=true
GOTO:GO

:uninstalloption
set uninstalloption=true
GOTO:GO


:GO

pushd

if  "%installoption%" == "true" goto installparm

if  "%uninstalloption%" == "true" goto uninstallparm

:installparm
  if NOT EXIST "%WVS_ROOT%\ifix\%APARID%\%FIXFILENAME%.bak" goto installifix
    echo "Ifix_%APARID%: Ifix %APARID% is applied, please uninstall before trying to reinstall ifix"
    goto:EOF

:installifix

 @rem # Check that the ifix files are found

 @echo Ifix_%APARID%: Checking for ifix files ...
 @echo Ifix_%APARID%: Checking for ifix files ...  >> "%WVS_ROOT%\log\%APARID%.log"
  if NOT EXIST "%~dp0%FIXFILENAME%" goto missing
      @echo Ifix_%APARID%: Ifix files found.. proceeding to install ifix
      @echo Ifix_%APARID%: Ifix files found.. proceeding to install ifix >> "%WVS_ROOT%\log\%APARID%.log"
      @mkdir "%WVS_ROOT%\ifix\%APARID%"

      echo Ifix_%APARID%: Stopping WebSphere Application Server
      echo Ifix_%APARID%: Stopping WebSphere Application Server >> "%WVS_ROOT%\log\%APARID%.log"
      call "%WAS_HOME%\bin\stopServer.bat" server1 -quiet      >> "%WVS_ROOT%\log\%APARID%.log"
      if ERRORLEVEL -10  (
         echo Ifix_%APARID%: WebSphere Application Server Successfully stopped.
         echo Ifix_%APARID%: WebSphere Application Server Successfully stopped.  >> "%WVS_ROOT%\log\%APARID%.log"
      ) else (
         echo.
         echo Ifix_%APARID%: WebSphere Application Server Failed to stop Successfully. Exiting ifix installation.
         echo Ifix_%APARID%: WebSphere Application Server Failed to stop Successfully.  Exiting ifix installation. >> "%WVS_ROOT%\log\%APARID%.log"
         echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\%APARID%.log"
         goto:EOF
      )
      timeout /T 20 /NOBREAK  >>  "%WVS_ROOT%\log\%APARID%.log"

      @rem Backup SIV config files ----------------------------------------------------
      echo Ifix_%APARID%: Backing up SIV config files... >> "%WVS_ROOT%\log\%APARID%.log"
      echo Ifix_%APARID%: Backing up SIV config files... 
      mkdir "%WVS_ROOT%\ifix\%APARID%\confbck" >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsweb.war\WEB-INF\ibm-web-bnd.xmi" "%WVS_ROOT%\ifix\%APARID%\confbck" >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsweb.war\WEB-INF\web.xml" "%WVS_ROOT%\ifix\%APARID%\confbck" >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsejb.jar\META-INF\ibm-ejb-jar-bnd.xmi" "%WVS_ROOT%\ifix\%APARID%\confbck" >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsejb.jar\META-INF\ejb-jar.xml" "%WVS_ROOT%\ifix\%APARID%\confbck" >> "%WVS_ROOT%\log\%APARID%.log"
      echo Ifix_%APARID%: SIV config backup complete. >> "%WVS_ROOT%\log\%APARID%.log"
      @rem ----------------------------------------------------------------------------

      copy /y "%~dp0Ifix_%APARID%.bat" "%WVS_ROOT%\ifix\."    >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%~dp0stopVoiceServer.jacl" "%WVS_ROOT%\ifix\%APARID%\."  >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WVS_ROOT%\%DESTDIR%\%FIXFILENAME%" "%WVS_ROOT%\ifix\%APARID%\%FIXFILENAME%.bak"   >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WVS_ROOT%\%DESTDIR2%\%FIXFILENAME2%" "%WVS_ROOT%\ifix\%APARID%\%FIXFILENAME2%.bak" >> "%WVS_ROOT%\log\%APARID%.log"

      copy /y "%~dp0%FIXFILENAME%" "%WVS_ROOT%\%DESTDIR%\."     >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%~dp0%FIXFILENAME2%" "%WVS_ROOT%\%DESTDIR2%\."   >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%~dp0installEar.py" "%WVS_ROOT%\ifix\%APARID%\."     >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%~dp0updateClasspaths.py" "%WVS_ROOT%\ifix\%APARID%\."     >> "%WVS_ROOT%\log\%APARID%.log"


      echo Ifix_%APARID%: Starting WebSphere Application Server
      echo Ifix_%APARID%: Starting WebSphere Application Server >> "%WVS_ROOT%\log\%APARID%.log"
      call "%WAS_HOME%\bin\startServer.bat" server1 -quiet      >> "%WVS_ROOT%\log\%APARID%.log"

      if %ERRORLEVEL% EQU 0  (
         echo Ifix_%APARID%: WebSphere Application Server Successfully started.
         echo Ifix_%APARID%: WebSphere Application Server Successfully started.  >> "%WVS_ROOT%\log\%APARID%.log"
      ) else (
         echo.
         echo Ifix_%APARID%: WebSphere Application Server Failed to start Successfully. Exiting ifix installation.
         echo Ifix_%APARID%: WebSphere Application Server Failed to start Successfully. Exiting ifix installation.  >> "%WVS_ROOT%\log\%APARID%.log"
         echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\%APARID%.log"
         goto:EOF
      )

      echo Ifix_%APARID%: Stopping  WebSphere Voice Server
      echo Ifix_%APARID%: Stopping  WebSphere Voice Server  >> "%WVS_ROOT%\log\%APARID%.log"
      call "%WAS_HOME%\bin\wsadmin.bat" -f "%~dp0stopVoiceServer.jacl"  %WAS_NODE% >> "%WVS_ROOT%\log\%APARID%.log"


      if ERRORLEVEL -10  (
         echo Ifix_%APARID%: Voice Server Successfully stopped.
         echo Ifix_%APARID%: Voice Server Successfully stopped.  >> "%WVS_ROOT%\log\%APARID%.log"
      ) else (
         echo.
         echo Ifix_%APARID%: Voice Server encountered a failure during stopping. Exiting ifix installation.
         echo Ifix_%APARID%: Voice Server encountered a failure during stopping. Exiting ifix installation.  >> "%WVS_ROOT%\log\%APARID%.log"
         echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\%APARID%.log"
         goto:EOF
      )

      echo Ifix_%APARID%: Updating WebSphere Voice Server J2EE Application
      echo Ifix_%APARID%: Updating WebSphere Voice Server J2EE Application     >> "%WVS_ROOT%\log\%APARID%.log"
      cd /D "%WVS_ROOT%"   >> "%WVS_ROOT%\log\%APARID%.log"

      call "%WAS_HOME%\bin\wsadmin.bat" -lang jython -f "%WVS_ROOT%\ifix\%APARID%\installEar.py" "installEar.py" "./%DESTDIR%" "%APPNAME%"  "WVS-%WAS_NODE%" "%WAS_NODE%" "server1" >> "%WVS_ROOT%\log\%APARID%.log"
      echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\%APARID%.log"

      if %ERRORLEVEL% EQU 0  (
         echo.
         echo.
         echo Ifix_%APARID%: Ifix is now applied, please reboot the system
         echo Ifix_%APARID%: Ifix is now applied, please reboot the system  >> "%WVS_ROOT%\log\%APARID%.log"
      ) else (
         echo.
         echo.
         echo Ifix_%APARID%: Ifix encountered a failure during update of the WVS Application, please uninstall the ifix.
         echo Ifix_%APARID%: Ifix encountered a failure during update of the WVS Application, please uninstall the ifix.  >> "%WVS_ROOT%\log\%APARID%.log"
         echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\%APARID%.log"
      )

      @rem Restore SIV config files ---------------------------------------------------
      echo Ifix_%APARID%: Restoring SIV config files... >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WVS_ROOT%\ifix\%APARID%\confbck\ibm-web-bnd.xmi" "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsweb.war\WEB-INF" >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WVS_ROOT%\ifix\%APARID%\confbck\web.xml" "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsweb.war\WEB-INF" >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WVS_ROOT%\ifix\%APARID%\confbck\ibm-ejb-jar-bnd.xmi" "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsejb.jar\META-INF" >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WVS_ROOT%\ifix\%APARID%\confbck\ejb-jar.xml" "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsejb.jar\META-INF" >> "%WVS_ROOT%\log\%APARID%.log"

      rmdir "%WVS_ROOT%\ifix\%APARID%\confbck" /S /Q >> "%WVS_ROOT%\log\%APARID%.log"
      echo Ifix_%APARID%: SIV config files restored. >> "%WVS_ROOT%\log\%APARID%.log"
      @rem ----------------------------------------------------------------------------

      goto:EOF

    @rem else
:missing
      echo Ifix_%APARID%: Ifix files missing, please be sure this script is in same directory as the binary files
      goto:EOF



:uninstallparm

if NOT "%uninstalloption%" == "true" goto :EOF
@rem # Check that the ifix backup files are found
 echo Ifix_%APARID%: Checking for ifix backup files ...
 echo Ifix_%APARID%: Checking for ifix backup files ... >> "%WVS_ROOT%\log\%APARID%.log"

   if not exist "%WVS_ROOT%\ifix\%APARID%\%FIXFILENAME%.bak" goto:unmissing
      echo Ifix_%APARID%: Ifix backup files found.. proceeding to un-install ifix
      echo Ifix_%APARID%: Ifix backup files found.. proceeding to un-install ifix >> "%WVS_ROOT%\log\%APARID%.log"

      echo Ifix_%APARID%: Stopping WebSphere Application Server
      echo Ifix_%APARID%: Stopping WebSphere Application Server >> "%WVS_ROOT%\log\%APARID%.log"
      call "%WAS_HOME%\bin\stopServer.bat" server1 -quiet >> "%WVS_ROOT%\log\%APARID%.log"
      if ERRORLEVEL -10  (
         echo Ifix_%APARID%: WebSphere Application Server Successfully stopped.
         echo Ifix_%APARID%: WebSphere Application Server Successfully stopped.  >> "%WVS_ROOT%\log\%APARID%.log"
      ) else (
         echo.
         echo Ifix_%APARID%: WebSphere Application Server Failed to stop Successfully. Exiting ifix installation.
         echo Ifix_%APARID%: WebSphere Application Server Failed to stop Successfully.  Exiting ifix installation. >> "%WVS_ROOT%\log\%APARID%.log"
         echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\%APARID%.log"
         goto:EOF
      )
      timeout /T 20 /NOBREAK  >>  "%WVS_ROOT%\log\%APARID%.log"

      @rem Backup SIV config files ----------------------------------------------------
      echo Ifix_%APARID%: Backing up SIV config files... >> "%WVS_ROOT%\log\%APARID%.log"
      echo Ifix_%APARID%: Backing up SIV config files... 
      mkdir "%WVS_ROOT%\ifix\%APARID%\confbck" >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsweb.war\WEB-INF\ibm-web-bnd.xmi" "%WVS_ROOT%\ifix\%APARID%\confbck" >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsweb.war\WEB-INF\web.xml" "%WVS_ROOT%\ifix\%APARID%\confbck" >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsejb.jar\META-INF\ibm-ejb-jar-bnd.xmi" "%WVS_ROOT%\ifix\%APARID%\confbck" >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsejb.jar\META-INF\ejb-jar.xml" "%WVS_ROOT%\ifix\%APARID%\confbck" >> "%WVS_ROOT%\log\%APARID%.log"
      echo Ifix_%APARID%: SIV config backup complete. >> "%WVS_ROOT%\log\%APARID%.log"
      @rem ----------------------------------------------------------------------------


      copy /y "%~dp0Ifix_%APARID%.bat" "%WVS_ROOT%\ifix\."    >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WVS_ROOT%\ifix\%APARID%\%FIXFILENAME%.bak"  "%WVS_ROOT%\%DESTDIR%\%FIXFILENAME%"   >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WVS_ROOT%\ifix\%APARID%\%FIXFILENAME2%.bak" "%WVS_ROOT%\%DESTDIR2%\%FIXFILENAME2%" >> "%WVS_ROOT%\log\%APARID%.log"
      


      echo Ifix_%APARID%: Starting WebSphere Application Server
      call "%WAS_HOME%\bin\startServer.bat" server1 -quiet >> "%WVS_ROOT%\log\%APARID%.log"

      if %ERRORLEVEL% EQU 0  (
         echo Ifix_%APARID%: WebSphere Application Server Successfully started.
         echo Ifix_%APARID%: WebSphere Application Server Successfully started.  >> "%WVS_ROOT%\log\%APARID%.log"
      ) else (
         echo Ifix_%APARID%: WebSphere Application Server Failed to start Successfully.
         echo Ifix_%APARID%: WebSphere Application Server Failed to start Successfully.  >> "%WVS_ROOT%\log\%APARID%.log"
         echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\%APARID%.log"
      )

      echo Ifix_%APARID%: Updating WebSphere Voice Server J2EE Application
      echo Ifix_%APARID%: Updating WebSphere Voice Server J2EE Application >> "%WVS_ROOT%\log\%APARID%.log"

      cd /D "%WVS_ROOT%"
      call "%WAS_HOME%\bin\wsadmin.bat" -lang jython -f "%WVS_ROOT%\ifix\%APARID%\installEar.py" "installEar.py" "./%DESTDIR%" "%APPNAME%" "WVS-%WAS_NODE%" "%WAS_NODE%"  "server1" >> "%WVS_ROOT%\log\%APARID%.log"

      if %ERRORLEVEL% EQU 0  (
         echo.
         echo.
         echo Ifix_%APARID%: Ifix is now uninstalled, please reboot the system
         echo Ifix_%APARID%:  Please remove the "%WVS_ROOT%\ifix\%APARID%" directory before attempting a subsequent install of this ifix.
         echo Ifix_%APARID%: Ifix is now uninstalled, please reboot the system  >> "%WVS_ROOT%\log\%APARID%.log"
      ) else (
         echo.
         echo.
         echo Ifix_%APARID%: Ifix encountered a failure during update of the WVS Application, please retry uninstalling the ifix.
         echo Ifix_%APARID%: Ifix encountered a failure during update of the WVS Application, please retry uninstalling the ifix.  >> "%WVS_ROOT%\log\%APARID%.log"
         echo %ERRORLEVEL% >>  "%WVS_ROOT%\log\%APARID%.log"
      )
      
      @rem Restore SIV config files ---------------------------------------------------
      echo Ifix_%APARID%: Restoring SIV config files... >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WVS_ROOT%\ifix\%APARID%\confbck\ibm-web-bnd.xmi" "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsweb.war\WEB-INF" >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WVS_ROOT%\ifix\%APARID%\confbck\web.xml" "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsweb.war\WEB-INF" >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WVS_ROOT%\ifix\%APARID%\confbck\ibm-ejb-jar-bnd.xmi" "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsejb.jar\META-INF" >> "%WVS_ROOT%\log\%APARID%.log"
      copy /y "%WVS_ROOT%\ifix\%APARID%\confbck\ejb-jar.xml" "%WAS_HOME%\profiles\AppSrv01\config\cells\%WAS_CELL%\applications\WVS-%WAS_NODE%.ear\deployments\WVS-%WAS_NODE%\wvsejb.jar\META-INF" >> "%WVS_ROOT%\log\%APARID%.log"

      rmdir "%WVS_ROOT%\ifix\%APARID%\confbck" /S /Q >> "%WVS_ROOT%\log\%APARID%.log"
      echo Ifix_%APARID%: SIV config files restored. >> "%WVS_ROOT%\log\%APARID%.log"
      @rem ----------------------------------------------------------------------------

      goto :END

:unmissing
      echo Ifix_%APARID%: Ifix backup files missing, uninstall not performed

popd
:END


